/* rdils - read an ILS format simulus file */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#ifdef MSDOS
#include <io.h>
#else
#define _O_BINARY    0
#define _O_RDONLY    O_RDONLY
#define _close       close
#define _write       write
#define _read        read
#endif
#ifdef linux
#include <unistd.h>
void    swab();
#endif
#define _open        open
#define _lseek       lseek
#define _swab        swab

#define ILS     -32000
#define BLKSIZ  256
#define STR_LEN 80

int    opnblk();
int    rdblk();
void   clsblk();
void   getstr();

extern short cpu_lsb;

int
rdils(filnam, buffer, buflen, prate, pnpts)	
char    filnam[];
short buffer[];
long buflen;
float  *prate;
short    *pnpts;
{
    char  str[STR_LEN];
    short itok = 0, ntok = 0, toksiz = 0, ofst = 1;
    short fd, nblk, blocks, *ils_header, *hitch;
    long i;
    double  pow();

    fd = opnblk(filnam);	/* open the file */
    if (fd < 0)
	return (fd);

    ils_header = buffer;
    (void) rdblk(fd, 0, ils_header, 1);	/* read ils_header */
    if (ils_header[62] != ILS) {
	clsblk(fd);
	return (ILS);
    }
    *pnpts = ils_header[5] * BLKSIZ;
    *prate = ils_header[61] * pow(10., ils_header[60] - 3.);
    nblk = ils_header[5];
    if (ils_header[63] == 11111) {
	hitch = buffer;
	(void) rdblk(fd, nblk + 1, hitch, 1);	/* read hitch */
	ntok = hitch[0];
	toksiz = hitch[1];
	if (ntok > 1) {
	    printf("token number (1-%d) : ", ntok);
	    fflush(stdout);
	    getstr(str);
	    itok = atoi(str);
	    if (itok > 0 && itok <= ntok) {
		nblk = toksiz / BLKSIZ;
		ofst = 1 + (itok - 1) * nblk;
	    }
	}
    }
    blocks = buflen / BLKSIZ;
    if (blocks > nblk)
	blocks = nblk;

    *pnpts = rdblk(fd, ofst, buffer, blocks);	/* read data */
    clsblk(fd);

    for (i = blocks * BLKSIZ; i < buflen; i++)
	buffer[i] = 0;

    return (fd);
}

/*****************************************************************************/

int
opnblk(file)
/*
 * open a file in raw mode for block io.
 * return a file descriptor.
 */
char   *file;
{
    short     fd, oflg;

    oflg = (short) (_O_RDONLY | _O_BINARY);
    fd = _open(file, oflg, 0);
    return (fd);
}

int
rdblk(fd, block, buf, blocks)
/* read from fd, blocks into buf starting at block */
short fd, block, blocks;
short *buf;
{
    long    offset;
    unsigned int count, rd;

    offset = block * 512L;
    (void) _lseek(fd, offset, 0);	/* seek from block 0 */
    count = 512 * (unsigned int) blocks;
    rd = _read(fd, (char *) buf, count);

    if (cpu_lsb != 0)
	_swab((char *) buf, (char *) buf, (int) rd);	/* swap bytes */

    return (rd / 2);
}

void
clsblk(fd)
short fd;
{
    _close(fd);
}
